# lib/goog/net/xmlhttpfactory.js

    1// Copyright 2010 The Closure Library Authors. All Rights Reserved.2//3// Licensed under the Apache License, Version 2.0 (the "License");4// you may not use this file except in compliance with the License.5// You may obtain a copy of the License at6//7//      http://www.apache.org/licenses/LICENSE-2.08//9// Unless required by applicable law or agreed to in writing, software10// distributed under the License is distributed on an "AS-IS" BASIS,11// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.12// See the License for the specific language governing permissions and13// limitations under the License.1415/**16 * @fileoverview Interface for a factory for creating XMLHttpRequest objects17 * and metadata about them.18 * @author dbk@google.com (David Barrett-Kahn)19 */2021goog.provide('goog.net.XmlHttpFactory');22232425/**26 * Abstract base class for an XmlHttpRequest factory.27 * @constructor28 */29goog.net.XmlHttpFactory = function() {30};313233/**34 * Cache of options - we only actually call internalGetOptions once.35 * @type {Object}36 * @private37 */38goog.net.XmlHttpFactory.prototype.cachedOptions_ = null;394041/**42 * @return {!(XMLHttpRequest|GearsHttpRequest)} A new XMLHttpRequest instance.43 */44goog.net.XmlHttpFactory.prototype.createInstance = goog.abstractMethod;454647/**48 * @return {Object} Options describing how xhr objects obtained from this49 *     factory should be used.50 */51goog.net.XmlHttpFactory.prototype.getOptions = function() {52  return this.cachedOptions_ ||53      (this.cachedOptions_ = this.internalGetOptions());54};555657/**58 * Override this method in subclasses to preserve the caching offered by59 * getOptions().60 * @return {Object} Options describing how xhr objects obtained from this61 *     factory should be used.62 * @protected63 */64goog.net.XmlHttpFactory.prototype.internalGetOptions = goog.abstractMethod;